from LTSPAgent.plugin import Plugin
from BaseHTTPServer import HTTPServer, BaseHTTPRequestHandler
from SocketServer import ThreadingMixIn
import threading, json, urlparse

class jsonHandler(BaseHTTPRequestHandler):
    def log_message(self, format, *args):
        return

    def do_POST(self):
        request=self.path.split('/')

        if len(request) != 3 or request[2] != "json":
            self.send_response(404)
            self.end_headers()
            return

        plugin=request[1]
        if not plugin in self.server.plugins:
            self.send_response(404)
            self.end_headers()
            return

        if not hasattr(self.server.plugins[plugin],'json_handler'):
            self.send_response(404)
            self.end_headers()
            return

        try:
            length=self.headers.getheader('content-length')
            content=self.rfile.read(int(length))
            post=urlparse.parse_qs(content)
            if "query" in post:
                query=json.loads(post['query'][0])
            else:
                self.send_response(404)
                self.end_headers()
                return
        except:
            self.send_response(404)
            self.end_headers()
            return

        if not "action" in query:
            self.send_response(500)
            self.end_headers()
            return

        self.send_response(200)
        self.end_headers()
        self.wfile.write(json.dumps(getattr(self.server.plugins[plugin],'json_handler')(query,self.client_address)))
        self.wfile.write('\n')
        return

class ThreadedHTTPServer(ThreadingMixIn, HTTPServer):
    """Handle requests in a separate thread."""

class jsonlink(Plugin):
    """Export another plugin's functions over JSON"""

    def init_plugin(self):
        server = ThreadedHTTPServer((self.get_config_path(self.config,'general','bindaddr'), int(self.get_config_path(self.config,'general','bindport'))), jsonHandler)
        server.plugins=self.plugins
        server.serve_forever()
